%%Pomoczniczo zdefiniowana (w odrbnym pliku) przykadowa funkcja badana :%
%%%-------------------------------------    
%%function [Yrow] = SinExpXPolynomial(X)
%%Yrow = X.*sin(exp(X.^(4/3)-X));
%Bisection method - metody bisekcji, znajdywania pierwiastkw badanej funkcji%
%Przykadowe (wielokrotne) wywoania z wyk. listy we/wy argumentw funkcji:
%%-----------------------------------
%X=0.75:0.01:3.75; % przykadowy zakres przedziau poszukiwa pierwiastka 
%Y=SinExpXPolynomial(X); % przykadowe obliczanie przeciwdziedziny, wzgldem dziedziny X %
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[0.125 3.000],100,0.05);
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[0.250 3.000],100,0.05);
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[1.000 3.000],100,0.05);
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[2.000 3.000],100,0.05);
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[2.500 3.000],100,0.05);
%%-----------------------------------
%X=0.75:0.01:3.75; % przykadowy zakres przedziau poszukiwa pierwiastka
%Y=SinExpXPolynomial(X); % przykadowe obliczanie przeciwdziedziny, wzgldem dziedziny X %
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[2.600 3.520],100,0.05);
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[2.700 3.520],100,0.05);
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[2.750 3.520],100,0.05);
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[2.750 3.500],100,0.05);
%[rts] = pierwiastek_metody_prostej_dwudzielnej('SinExpXPolynomial',[2.750 3.250],100,0.05);
%/////////////////////////////////////////////////////////////////////////%
function [rts] = pierwiastek_metody_prostej_dwudzielnej(feval_str,intvls_ab,steps,tolr);
%---------------------
a = intvls_ab(1);   % pobierz z wiersza 2giego argumentu pooenie punktu a na osi X%
b = intvls_ab(2);   % pobierz z wiersza 2giego argumentu pooenie punktu b na osi Y% 
%------------%rozwi szereg argumentu X oraz linii zerowej (wzdu osi X) %
X = linspace(a,b,steps);% inaczej: X = a : (b-a)/(steps-1) : b;%%!%%
Z = 0.*X;
%---------------------
Y = feval(feval_str,X); % wyznacz funkcj o nazwie okrelonej w 1wszym argumencie %
figure,
plot(X,Y,'b--');        % wykrel funkcj badan na wystpienie pierwistka%
hold on;                % wykres do dalszego uzupenienia, - jego uchwyt wstrzymany%
plot(X,Z,'k-');         % wykrel lini zerow (wzdu osi X)%
title(['Przebieg funkcji: ' feval_str ', w znajdywaniu pierw. metod bisekcji']);
xlabel(['przebieg funkcji badanej - linia niebieska przerywana, linia bisekcji - linia czerw. przeryw.' ...
         ', bieca zmiana jednej z granic przedziau [a,b] - czarne romby, wart. funk. na kracach bie.'...
         'przedz. [a,b] - czarne krzyyki']);
ylabel(['Wartoci funkcji: ' feval_str]);
%---------------------
errs = 2;              % ustaw bd na przypadkow oraz znaczn warto (przed wejciem do ptli)% 
licznik = 0;           % ustaw licznik przebiegu ptli while na zero - wart. pocz. %
% pocztek ptli gwnej - kryterium wyjcia- ocen marginesu bdu znajdywania pierwiastka funkcji %
while (errs >= tolr)    % dopki bd nie spadnie poniej wymaganej toleracji, kontynuuj ptl while %
    Ya = feval(feval_str,a); % oce warto funkcji na kocach przedziau [a,b] %
    disp(['Warto pocztkowa a przedziau [a,b]: ' num2str(a) ' z wartoci funkcji Y(a): ' num2str(Ya)]);
    Yb = feval(feval_str,b);
    disp(['Warto pocztkowa b przedziau [a,b]: ' num2str(b) ' z wartoci funkcji Y(b): ' num2str(Yb)]);
    %---
    plot(a,Ya,'rd');plot(b,Yb,'rd'); % oznacz wartoci funkcji na kracach przed. pocz. czerwn. rombami%
    ab  = linspace(a,b,steps);       % wyznacz szereg dziedziny w przedziale [a,b]% 
    Yab = linspace(Ya,Yb,steps);     % wyznacz liniowy szereg przeciwdzieny w przedziale [a,b]%
    plot(ab,Yab,'r-.');              % wykrel prost - sieczn funkcji w przedziale [a,b]%
    %-
    rts = Ya*(b - a)/(Ya - Yb) + a; % z podobiestwa trjktw znajd przybli. pierwiast. - przecicie osi X %
    Yrts = feval(feval_str,rts);    % znajd warto funkcji w miejscu tego przybli. pierwiast. % 
    errs = abs(Yrts);               % jego warto bezwgldna, jest jednoczenie bdem znalezienia pierw. %
    plot(rts,0,'kd');            % wykrel gwiazdk przyblion lokalizacj pierwiastka (na osi X na czarno) %
    plot(rts,Yrts,'bd');         % wykrel rombem przyblion lokalizacj pierw. w przeciwdziedzinie %
    LV = linspace(0,Yrts,steps); % rozwin przeciwdziedzin-wsprzdne wys. linii pionowej
    plot(rts*ones(1,steps),LV,'k--'); % wykr. ln. pion., od punktu na osi X do wart.funk. w. punkt. na osi X
        %---
    if (Yrts > 0)                % jeli w przeciwdziedzinie jest to warto dodatnia %
      a = rts;  
     Ya = Yrts;                  % zawaj przedzia [a,b] z lewej strony %
     disp(['Przedzial [a,b] zawony od lewej strony (od strony punktu a)']);
     %---
    elseif (Yrts < 0);           % jeli w przeciwdziedizenie jest to warto ujemna %
    %---
      b  = rts;
     Yb = Yrts;                  % zawaj przedzia [a,b] w prawej strony %
     disp(['Przedzial [a,b] zawony od prawej strony (od strony punktu  b)']);
    end;
    %---
     plot(a,Ya,'k+');plot(b,Yb,'k+');
    %---
    beep;
    licznik = licznik + 1        % zwiksz licznik przebiegu  ptli o jeden%
end;
%-----
hold off;
%/////////////////////////koniec definicji gwnego m-skryptu////////%
%
%//////////TUTAJ ZACZYNA SI DEFINICJA FUNKCJI PODRZDNEJ////////////%
%
%Przykadowa posta funkcji badanej - w poszukiwaniu jej pierwiastka%
%Skadnia:
%--------------------------------
%[Yrow] = SinExpXPolynomial(X);
%%Przykadowa lista we/wy wywoania funkcji:
%%-------------------------------
%X=0.75:0.01:3.25;
%[Y]=SinExpXPolynomial(X);
%plot(X,Y,'r-.');grid on;title('Testowa funkcja - w znajdywaniu pierwiastka');
%%-------------------------------
function [Yrow] = SinExpXPolynomial(X)
Yrow = X.*sin(exp(X.^(4/3)-X));
