function [Mout] = sharp_diamond(sz)
%wywoanie podrzdne funkcji "eye_diamond" w funkcji gwnej
D        = eye_diamond(sz);
[H,W]    = size(D);        %zbadaj rozmiar diamencika bez ostrych zakonczen
MD   = [D(1:sz     , 1:sz)     zeros(sz,1) D(1:sz     , sz+1:end);...
                               zeros(1,sz+sz+1);...
        D(sz+1:end , 1:sz)     zeros(sz,1) D(sz+1:end , sz+1:end)];
%np. skadnia na konkretnych liczbach, przy sz=4 wygldaaby, jak ponizej:
%Diament = [D(1:4,1:4) zeros(4,1) D(1:4,5:8);zeros(1,9); D(5:8,1:4) zeros(4,1) D(5:8,5:8)]
%wywoanie podrzdne funkcji "matrix_padarray" w funkcji gwnej
Mout = matrix_padarray(MD,0); %opatul dodatkowo 4-cwiartki diamencika murem z zer
Mout(sz+2,1)   = 1;    % w 4 rogach diamentu wstaw 'wyostrzajace' jedynki
Mout(1,sz+2)   = 1;
Mout(end,sz+2) = 1;
Mout(sz+2,end) = 1;

%%%%//////////////KONIEC DEFINICJI FUNKCJI GWNEJ: "sharp_diamond" ///////////////%

%%%%%%1szy m-skrypt podrzedny%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Mout] = eye_diamond(sz)
K = eye(sz);    % twrz macierz o rozmiarze sz na sz elementw z diagonaln przektn jedynek
L = fliplr(K);  % lustrzane odbicie left-right (flip left-right) macierzy L
M = flipud(K);  % lustrzane odbicie up-down (flip up-down) macierzy M
N = flipud(L);  % lustrzane odbicie up-down (flip up-down) macierzy L
%%stwrz macierz z ukonym krzyem o rozmiarze 2*sz na 2*sz elementw %%
LKNM = [L K ; N M];
Mout = LKNM;

%%%%%%%2gi m-skrypt podrzedny%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [Mout] = matrix_padarray(M,zerjed) % doslownie: opatul szeregiem (potem) zer lub jedynek
[H,W] = size(M); % zbadaj wysoko (H-height) i szeroko (W -width) macierz wejciowej M
%%%%%%%%%%%%%%%%%%%%%%%%
if nargin <2
    zerjed = 0;
end;
%%%%%%%%%%%%%%%%%%%%%%%%
switch zerjed  % instrukcja multiwyboru - tutaj pomidzy instrukcjami dla generacji zer, albo jedynek
    
 case 0   % w przypadku, gdy w drugim argumencie wejciowym zazadano zer
  Mout = [zeros(H,1) M zeros(H,1)];
  Mout = [zeros(1,W+2);Mout;zeros(1,W+2)];
 
 case 1  % w przypadku, gdy w 2-gim arg. we. zdecydowano o generacji jedynek
  Mout = [ones(H,1) M ones(H,1)];
  Mout = [ones(1,W+2);Mout;ones(1,W+2)];
 
end;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%